#ifndef TREE_HPP
#define TREE_HPP

#include "node.hpp"

class Tree {
public:
    // constructor
    Tree() = delete;
    Tree(double* particles, double* forces_, unsigned nParticles, double size, double* center);
    // destructor
    ~Tree();
    // update tree: visit each node, check if it needs to be split or merged (for example if a particle has left the region)
    void update();
    // drift tree: visit each node, update center of mass and center of mass velocity
    void drift(double dt);
    // kick tree: visit each node, update center of mass velocity
    void kick(double dt);
private:
    Node* root_;
    double* particles_;
    double* forces_;
    unsigned nParticles_;
    double size_;
    double center_[3];
};

#endif /* TREE_HPP */